package org.antlr.analysis;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.HashSet;
import org.antlr.analysis.DFA;
import org.antlr.analysis.SemanticContext;
import org.antlr.codegen.CodeGenerator;
import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroup;

public class AND extends SemanticContext.CommutativePredicate {
  public AND(SemanticContext a, SemanticContext b) {
    super(a, b);
  }
  
  public AND(HashSet<SemanticContext> contexts) {
    super(contexts);
  }
  
  public ST genExpr(CodeGenerator generator, STGroup templates, DFA dfa) {
    ST result = null;
    for (SemanticContext operand : this.operands) {
      ST eST;
      if (result == null) {
        result = operand.genExpr(generator, templates, dfa);
        continue;
      } 
      if (templates != null) {
        eST = templates.getInstanceOf("andPredicates");
      } else {
        eST = new ST("(<left>&&<right>)");
      } 
      eST.add("left", result);
      eST.add("right", operand.genExpr(generator, templates, dfa));
      result = eST;
    } 
    return result;
  }
  
  public String getOperandString() {
    return "&&";
  }
  
  public SemanticContext combinePredicates(SemanticContext left, SemanticContext right) {
    return SemanticContext.and(left, right);
  }
  
  public int calculateHashCode() {
    int hashcode = 0;
    for (SemanticContext context : this.operands)
      hashcode ^= context.hashCode(); 
    return hashcode;
  }
}
